GRANT SELECT ON dbinfo TO PUBLIC;
insert into tags (id, label) VALUES (0, 'Alle');
insert into tags (id, label) VALUES (1, 'konsistent');
insert into tags (id, label) VALUES (2, 'phasenvollstaendig');
insert into tags (id, label) VALUES (3, 'auswertbar');
insert into tags (id, label) VALUES (4, 'mpuls-auswertbar');

-- View: "master_tbl_view"

-- DROP VIEW master_tbl_view;

--CREATE OR REPLACE VIEW master_tbl_view AS 
-- SELECT master_tbl.id, master_tbl.phase, master_tbl.fkz,
-- master_tbl.beendigung_5, master_tbl.datum_feststellung,
-- master_tbl.art_beendigung, master_tbl.geburtsdatum, master_tbl.muttersprache,
-- master_tbl.staatsangehoerigkeit, master_tbl.vater, master_tbl.mutter, master_tbl.geschlecht,
-- master_tbl.erstgespraech, master_tbl.beendigung_nachbetreuung,
-- master_tbl.zugang_kompetenzagen, master_tbl.schulform, master_tbl.sv_aktiv,
-- master_tbl.sv_passiv, master_tbl.cm_end_schul
--    FROM master_tbl;
--
--    ALTER TABLE master_tbl_view OWNER TO ka_waskaauswertung_auswertung;
--    GRANT SELECT, UPDATE, INSERT, DELETE, REFERENCES, TRIGGER ON TABLE
--    master_tbl_view TO ka_waskaauswertung_auswertung;
--    GRANT INSERT ON TABLE master_tbl_view TO public;

CREATE OR REPLACE VIEW master_tbl_view AS 
 SELECT id, fkz, phase, geschlecht, erstgespraech, datum_feststellung,
 beendigung_5, datum_ende_beratung, beendigung_nachbetreuung, 
 art_beendigung, geburtsdatum, erwerbstaetigkeit_job, rechtlicher_kontext,
 schnittstelle_zu, bei_eintritt_ist_der_jugendliche, arbeitslosigkeit_1,
 bezug_alg2, bezug_alg1, dauer_nach_letzter_beschaeftigung, muttersprache,
 staatsangehoerigkeit, vater, mutter, anerkannte_behinderung,
 psychische_beeintraechtigungen, physische_beeintraechtigungen,
 schulabschluss_1, zugang_kompetenzagentur, vermittlung, schulart,
 schulpflichtig, ausbildung, umschulung, erwerbstatus, beschaeftigungsumfang,
 kategorien_nichterwerbsarbeit_nichtausbildung, veraenderungen_rechtskreis,
 allgschulpflichtig, prognose_liegt_vor
 FROM master_tbl;

    ALTER TABLE master_tbl_view OWNER TO ka_waskaauswertung_auswertung;
    GRANT SELECT, UPDATE, INSERT, DELETE, REFERENCES, TRIGGER ON TABLE
    master_tbl_view TO ka_waskaauswertung_auswertung;
    GRANT INSERT ON TABLE master_tbl_view TO public;

-- View: "nm_tags_cases_view"

-- DROP VIEW nm_tags_cases_view;

CREATE OR REPLACE VIEW nm_tags_cases_view AS 
 SELECT nm_tags_cases.id, nm_tags_cases.master_id AS case_id,
 nm_tags_cases.tag_id, nm_tags_cases.created
    FROM nm_tags_cases;

    ALTER TABLE nm_tags_cases_view OWNER TO ka_waskaauswertung_auswertung;
    GRANT SELECT, UPDATE, INSERT, DELETE, REFERENCES, TRIGGER ON TABLE
    nm_tags_cases_view TO ka_waskaauswertung_auswertung;
    GRANT SELECT ON TABLE nm_tags_cases_view TO public;


CREATE OR REPLACE VIEW master_tbl_eval_total_view AS
  SELECT * from master_tbl_view;

ALTER TABLE master_tbl_eval_total_view OWNER TO ka_waskaauswertung_auswertung;
GRANT SELECT, UPDATE, INSERT, DELETE, REFERENCES, TRIGGER ON TABLE
master_tbl_eval_total_view TO ka_waskaauswertung_auswertung;
GRANT INSERT ON TABLE master_tbl_eval_total_view TO public;

CREATE OR REPLACE VIEW tags_view 
    AS SELECT
        id,
        label,
        description,
        systemtag
    FROM tags;
GRANT SELECT ON TABLE tags_view TO public;


-- -- View: "geschlecht_tbl_view"
-- 
-- -- DROP VIEW geschlecht_tbl_view;
-- 
-- CREATE OR REPLACE VIEW geschlecht_tbl_view AS 
--  SELECT geschlecht_tbl.id, geschlecht_tbl.value
--     FROM geschlecht_tbl
--       WHERE geschlecht_tbl.id <> ALL (ARRAY[(-1), (-3)]);
-- 
--       ALTER TABLE geschlecht_tbl_view OWNER TO ka_waskaauswertung_auswertung;
--       GRANT SELECT, UPDATE, INSERT, DELETE, REFERENCES, TRIGGER ON TABLE
--       geschlecht_tbl_view TO ka_waskaauswertung_auswertung;
--       GRANT SELECT ON TABLE geschlecht_tbl_view TO public;
-- 

-- Function: create_nm_tag_case_ds(tagid int4, masterid int4)

-- DROP FUNCTION create_nm_tag_case_ds(tagid int4, masterid int4);

CREATE OR REPLACE FUNCTION create_nm_tag_case_ds(tagid int4, masterid int4)
  RETURNS int4 AS
  $BODY$
  BEGIN
      INSERT INTO nm_tags_cases (id, tag_id, master_id) 
              VALUES (coalesce((select max(id) from nm_tags_cases)+1, 1),
	      tagid, masterid);
	          RETURN 0;
		  END;
		  $BODY$
		    LANGUAGE 'plpgsql' VOLATILE SECURITY DEFINER;
		    ALTER FUNCTION create_nm_tag_case_ds(tagid int4, masterid
		    int4) OWNER TO postgres;
		    GRANT EXECUTE ON FUNCTION create_nm_tag_case_ds(tagid
		    int4, masterid int4) TO public;
		    GRANT EXECUTE ON FUNCTION create_nm_tag_case_ds(tagid
		    int4, masterid int4) TO postgres;

-- Function: delete_nm_tag_case_ds(tagid int4, masterid int4)

-- DROP FUNCTION delete_nm_tag_case_ds(tagid int4, masterid int4);

CREATE OR REPLACE FUNCTION delete_nm_tag_case_ds(tagid int4, masterid int4)
  RETURNS void AS
  $BODY$
  BEGIN
      DELETE FROM nm_tags_cases 
                  WHERE master_id = masterid AND tag_id = tagid; 
		  END;
		  $BODY$
		    LANGUAGE 'plpgsql' VOLATILE SECURITY DEFINER;
		    ALTER FUNCTION delete_nm_tag_case_ds(tagid int4, masterid
		    int4) OWNER TO postgres;
		    GRANT EXECUTE ON FUNCTION delete_nm_tag_case_ds(tagid
		    int4, masterid int4) TO public;
		    GRANT EXECUTE ON FUNCTION delete_nm_tag_case_ds(tagid
		    int4, masterid int4) TO postgres;

-- master_tbl_eval_totalview
CREATE OR REPLACE VIEW master_tbl_eval_total_view AS
  SELECT * from master_tbl_view;

ALTER TABLE master_tbl_eval_total_view OWNER TO ka_waskaauswertung_auswertung;
GRANT SELECT, UPDATE, INSERT, DELETE, REFERENCES, TRIGGER ON TABLE
master_tbl_eval_total_view TO public;
GRANT INSERT ON TABLE master_tbl_eval_total_view TO public;

-- logbuch table view
CREATE OR REPLACE VIEW ka_logbuch_tbl_view 
    AS SELECT * FROM ka_logbuch_tbl;
GRANT SELECT ON TABLE ka_logbuch_tbl_view TO public;
