BEGIN;

SET ROLE :db_adm;

INSERT INTO db_history (beschreibung, zeitpunkt)
       VALUES ('update_1_5_3/01-anonym-tagebuch.sql', current_timestamp);

CREATE OR REPLACE FUNCTION anonymize_logbuch(mid integer) 
RETURNS void 
LANGUAGE 'plpgsql' VOLATILE EXTERNAL SECURITY DEFINER
AS $$
BEGIN
    -- DELETE FROM ka_logbuch_tbl WHERE master_id = mid;
    UPDATE ka_logbuch_tbl SET
        uuid_id    = NULL,
        kurz_notiz = NULL,
        notiz      = NULL
    WHERE master_id = mid;
END;
$$;

REVOKE ALL     ON FUNCTION anonymize_logbuch(integer) FROM PUBLIC;
GRANT  EXECUTE ON FUNCTION anonymize_logbuch(integer) TO GROUP :admin_ka_group;


-- Wrapper Funktion die alle noetigen Funktionen zum Anonymisieren einer
-- Fallakte aufruft.
CREATE OR REPLACE FUNCTION anonymize_case_wrapper(mid integer)
RETURNS void AS
$$
BEGIN
	PERFORM anonymize_case(mid);
	PERFORM delete_all_fall_dokumente(mid);
	PERFORM delete_all_fall_termine(mid);
	PERFORM anonymize_logbuch(mid);
END;
$$ LANGUAGE plpgsql VOLATILE SECURITY DEFINER;

COMMIT;
