BEGIN;

SET ROLE :db_adm;

INSERT INTO db_history (beschreibung, zeitpunkt)
       VALUES ('update_1_5_6/06-rechtlicher_kontext_eintritt.sql', current_timestamp);

CREATE TABLE schnittstelle_zu_tbl (
    id SERIAL PRIMARY KEY NOT NULL,
    value VARCHAR(34) NOT NULL
);

REVOKE ALL ON TABLE schnittstelle_zu_tbl FROM PUBLIC;
REVOKE ALL ON TABLE schnittstelle_zu_tbl FROM :db_adm;
GRANT ALL ON TABLE schnittstelle_zu_tbl TO :db_adm;
GRANT SELECT ON TABLE schnittstelle_zu_tbl TO :cm_group;
GRANT SELECT ON TABLE schnittstelle_zu_tbl TO :admin_group;

INSERT INTO schnittstelle_zu_tbl (id, value) VALUES (-1, 'Keine Angabe');
INSERT INTO schnittstelle_zu_tbl (id, value) VALUES (0, 'SGB II');
INSERT INTO schnittstelle_zu_tbl (id, value) VALUES (1, 'SGB III');
INSERT INTO schnittstelle_zu_tbl (id, value) VALUES (2, 'SGB VIII');
INSERT INTO schnittstelle_zu_tbl (id, value) VALUES (3, 'ungeklärt');
INSERT INTO schnittstelle_zu_tbl (id, value) VALUES (4, 'SGB XII');
INSERT INTO schnittstelle_zu_tbl (id, value) VALUES (5, 'SGB IX');
INSERT INTO schnittstelle_zu_tbl (id, value) VALUES (6, 'Asylbewerberleistungsgesetz');
INSERT INTO schnittstelle_zu_tbl (id, value) VALUES (7, 'Bundesausbildungsförderungsgesetz');
INSERT INTO schnittstelle_zu_tbl (id, value) VALUES (8, 'keine Schnittstelle');

ALTER TABLE master_tbl DROP CONSTRAINT master_tbl_schnittstelle_zu_fkey;
ALTER TABLE master_tbl ADD FOREIGN KEY (schnittstelle_zu) REFERENCES schnittstelle_zu_tbl (id);

ALTER TABLE rechtlicher_kontext_tbl ALTER value TYPE VARCHAR(46);  
INSERT INTO rechtlicher_kontext_tbl (id, value) VALUES (6, 'Asylbewerberleistungsgesetz');
INSERT INTO rechtlicher_kontext_tbl (id, value) VALUES (7, 'Bundesausbildungsförderungsgesetz');
INSERT INTO rechtlicher_kontext_tbl (id, value) VALUES (8, 'kein Rechtskreis im Sinne des Leistungsbezugs');

COMMIT;
