\connect postgres postgres
BEGIN;
UPDATE pg_database SET datallowconn = TRUE where datname='waska_template';
COMMIT;
-- Anlegen von der Python-Scriptsprache für die Datenbank
\connect waska_maintenance postgres
BEGIN;
CREATE PROCEDURAL LANGUAGE 'plpythonu' HANDLER plpython_call_handler;

CREATE OR REPLACE FUNCTION waska_passgen(pw_length int) RETURNS text
  LANGUAGE 'plpythonu' VOLATILE
  AS $$
    from os import popen
    from random import sample
    pw = None
    try:
      try:
        pw = popen("/usr/bin/pwgen --ambiguous --numerals --symbols %s"
                    % pw_length)
        return pw.readline().strip()
      except:
        pop = [chr(c) for c in range(33,127+1)]
        return "".join(sample(pop, pw_length))
    finally:
      if pw:
        try: pw.close()
        except: pass
$$;
ALTER FUNCTION waska_passgen(int) OWNER TO pt_dlr;
REVOKE ALL ON FUNCTION waska_passgen(int) FROM public;
COMMIT;
\connect waska_template postgres
BEGIN;
CREATE PROCEDURAL LANGUAGE 'plpythonu' HANDLER plpython_call_handler;

CREATE OR REPLACE FUNCTION waska_passgen(pw_length int) RETURNS text
  LANGUAGE 'plpythonu' VOLATILE
  AS $$
    from os import popen
    from random import sample
    pw = None
    try:
      try:
        pw = popen("/usr/bin/pwgen --ambiguous --numerals --symbols %s"
                    % pw_length)
        return pw.readline().strip()
      except:
        pop = [chr(c) for c in range(33,127+1)]
        return "".join(sample(pop, pw_length))
    finally:
      if pw:
        try: pw.close()
        except: pass
$$;
ALTER FUNCTION waska_passgen(int) OWNER TO waska_role_adm;
REVOKE ALL ON FUNCTION waska_passgen(int) FROM public;

CREATE OR REPLACE FUNCTION waska_drop_role (
        username varchar(64),
        agency varchar(52)
  ) RETURNS boolean LANGUAGE 'plpgsql' VOLATILE EXTERNAL SECURITY DEFINER
  AS $$
  DECLARE
    db_user       varchar(128);
    status_revoke boolean;
  BEGIN
    -- IF position(quote_literal(agency) in session_user) != 4
    IF position(agency in session_user) != 4
    THEN
      RAISE EXCEPTION
          'Permission denied to drop role % in agency % by %.',
          quote_literal(username), quote_literal(agency), session_user;
    ELSE
      db_user := quote_ident('ka_' || agency || '_' || username);
      SELECT waska_revoke_connect(username, agency) INTO status_revoke;
      IF status_revoke
      THEN
        EXECUTE 'DROP ROLE ' || db_user ;
        RETURN true;
      END IF;
    END IF;
    RETURN false;
  END;
$$ ;
REVOKE ALL ON FUNCTION waska_drop_role(varchar, varchar) FROM public;

CREATE OR REPLACE FUNCTION waska_revoke_connect (
        username varchar(64),
        agency varchar(52)
  ) RETURNS boolean LANGUAGE 'plpgsql' VOLATILE EXTERNAL SECURITY DEFINER
  AS $$
  DECLARE 
    db_name  varchar(64);
    db_user  varchar(128);
  BEGIN
    -- IF position(quote_literal(agency) in session_user) != 4
    IF position(agency in session_user) != 4
    THEN
      RAISE EXCEPTION 
          'Permission denied to drop role % in agency % by %.',
          quote_literal(username), quote_literal(agency), session_user;
    ELSE
      db_name := quote_ident('ka_' || agency || '_db');
      db_user := quote_ident('ka_' || agency || '_' || username);
      EXECUTE 'REVOKE CONNECT ON DATABASE ' || db_name
          || ' FROM ' || db_user ;
      RETURN true;
    END IF;
    RETURN false;
  END;
$$ ;
REVOKE ALL ON FUNCTION waska_revoke_connect( varchar, varchar ) FROM public;
GRANT EXECUTE ON FUNCTION waska_revoke_connect( varchar, varchar ) TO waska_role_adm;
UPDATE pg_database SET datallowconn = FALSE where datname='waska_template';
ALTER FUNCTION waska_revoke_connect( varchar, varchar ) OWNER TO waska_role_adm;
COMMIT;
