SET ROLE :adm_ka_owner;
-- 
-- Funktion zum Setzen des Benutzerpassworts
--
DROP FUNCTION ka_set_password("login" character varying, pw character varying);
CREATE OR REPLACE FUNCTION ka_set_password(loginname varchar, pw varchar)
    RETURNS text 
    LANGUAGE 'plpgsql'
    AS $$
BEGIN
    EXECUTE 'ALTER USER ' || loginname || ' WITH PASSWORD ' 
              || quote_literal(pw);
    EXECUTE ka_unset_passrefresh_flag(loginname);
          RETURN pw::text;
    RETURN ''::text;
END;
$$ ;

REVOKE ALL ON FUNCTION ka_set_password(varchar, varchar) FROM PUBLIC;
GRANT EXECUTE ON FUNCTION ka_set_password(varchar, varchar) 
                TO :admin_ka_group;
GRANT EXECUTE ON FUNCTION ka_set_password(varchar, varchar)    
                TO :cm_ka_group;
