--
-- views for master table and repeat groups
--
BEGIN;
SET ROLE :db_adm;

-- Die Views muessen explizit geloescht werden, da man
-- mit einem REPLACE die Spaltenanzahl nicht aendern kann.

DROP VIEW master_tbl_view;
DROP VIEW rg_kompetenzfestellung_tbl_view;
DROP VIEW rg_angebote_bildenden_bereich_tbl_view;
DROP VIEW rg_angebote_berufsvorbereitung_tbl_view;
DROP VIEW rg_angebote_berufliche_qualifizierung_tbl_view;
DROP VIEW rg_angebote_lebensbewaeltigung_tbl_view;

CREATE OR REPLACE VIEW master_tbl_view
AS SELECT master_tbl.* FROM master_tbl
WHERE
    master_tbl.bearbeiter_id = getuserid()
    OR master_tbl.id IN (
        SELECT nm.master_id from nm_benutzer_master_tbl nm
            WHERE nm.benutzer_id = getuserid())
    OR pg_has_role('admin_ka','MEMBER');

CREATE OR REPLACE RULE master_tbl_update_rule AS ON UPDATE TO master_tbl_view
DO INSTEAD UPDATE master_tbl SET
    einverstaendniserklaerung = NEW.einverstaendniserklaerung,
    fkz = NEW.fkz,
    name_kompetenzagentur = NEW.name_kompetenzagentur,
    vorname = NEW.vorname,
    name = NEW.name,
    erstgespraech = NEW.erstgespraech,
    zugang_kompetenzagentur = NEW.zugang_kompetenzagentur,
    kundennummer = NEW.kundennummer,
    schulpflichtig = NEW.schulpflichtig,
    noch_schueler = NEW.noch_schueler,
    bei_eintritt_ist_der_jugendliche = NEW.bei_eintritt_ist_der_jugendliche,
    rechtlicher_kontext = NEW.rechtlicher_kontext,
    schnittstelle_zu = NEW.schnittstelle_zu,
    kontaktdaten_arge = NEW.kontaktdaten_arge,
    kundennummer_arge = NEW.kundennummer_arge,
    kontaktdaten_agentur_fuer_arbeit = NEW.kontaktdaten_agentur_fuer_arbeit,
    kundennummer_agentur_fuer_arbeit = NEW.kundennummer_agentur_fuer_arbeit,
    kundennummer_jugendamt = NEW.kundennummer_jugendamt,
    kontaktdaten_jugendamt = NEW.kontaktdaten_jugendamt,
    kontaktdaten_schule = NEW.kontaktdaten_schule,
    schulname = NEW.schulname,
    kontaktdaten_gerichtshilfe = NEW.kontaktdaten_gerichtshilfe,
    kundennummer_gerichtshilfe = NEW.kundennummer_gerichtshilfe,
    kontaktdaten_weitere_institutionen = NEW.kontaktdaten_weitere_institutionen,
    vorname_1 = NEW.vorname_1,
    name_1 = NEW.name_1,
    geschlecht = NEW.geschlecht,
    geburtsdatum = NEW.geburtsdatum,
    familienstand = NEW.familienstand,
    strasse = NEW.strasse,
    plz = NEW.plz,
    wohnort = NEW.wohnort,
    groesse_wohnort = NEW.groesse_wohnort,
    zweiter_wohnort = NEW.zweiter_wohnort,
    vorwahl = NEW.vorwahl,
    telefon_1 = NEW.telefon_1,
    mobiltelefon = NEW.mobiltelefon,
    email = NEW.email,
    telefon_sonstige = NEW.telefon_sonstige,
    geburtsland = NEW.geburtsland,
    geburtsland_sonstige_nennung = NEW.geburtsland_sonstige_nennung,
    muttersprache = NEW.muttersprache,
    muttersprache_sonstige_nennung = NEW.muttersprache_sonstige_nennung,
    staatsangehoerigkeit = NEW.staatsangehoerigkeit,
    staatsangehoerigkeit_sonstige_nennung = NEW.staatsangehoerigkeit_sonstige_nennung,
    aufenthaltsstatus = NEW.aufenthaltsstatus,
    aufenthaltsdauer = NEW.aufenthaltsdauer,
    vater = NEW.vater,
    mutter = NEW.mutter,
    familiaere_situation_1 = NEW.familiaere_situation_1,
    vorname_2 = NEW.vorname_2,
    name_2 = NEW.name_2,
    vorwahl_1 = NEW.vorwahl_1,
    telefon_1_1 = NEW.telefon_1_1,
    mobiltelefon_1 = NEW.mobiltelefon_1,
    email_1 = NEW.email_1,
    geschwister = NEW.geschwister,
    anzahl_kinder = NEW.anzahl_kinder,
    haushalt_jugendlicher = NEW.haushalt_jugendlicher,
    alleinerziehend = NEW.alleinerziehend,
    familie_selbststaendig = NEW.familie_selbststaendig,
    familie_staatliche_unterstuetzung = NEW.familie_staatliche_unterstuetzung,
    jugendlicher_selbststaendig = NEW.jugendlicher_selbststaendig,
    jugendlicher_staatliche_unterstuetzung = NEW.jugendlicher_staatliche_unterstuetzung,
    jugendlicher_unterstuetzung_soziales_umfeld = NEW.jugendlicher_unterstuetzung_soziales_umfeld,
    wohnaufenthalt = NEW.wohnaufenthalt,
    arzt_gutachten_physisch = NEW.arzt_gutachten_physisch,
    physische_beeintraechtigungen = NEW.physische_beeintraechtigungen,
    physische_beeintraechtigungen_text = NEW.physische_beeintraechtigungen_text,
    arzt_gutachten_psychisch = NEW.arzt_gutachten_psychisch,
    psychische_beeintraechtigungen = NEW.psychische_beeintraechtigungen,
    psychische_beeintraechtigungen_text = NEW.psychische_beeintraechtigungen_text,
    mutter_2 = NEW.mutter_2,
    vater_2 = NEW.vater_2,
    grosseltern = NEW.grosseltern,
    geschwister_2 = NEW.geschwister_2,
    pflegefamilie_1 = NEW.pflegefamilie_1,
    stiefmutter = NEW.stiefmutter,
    stiefvater = NEW.stiefvater,
    verwandte_1 = NEW.verwandte_1,
    partner = NEW.partner,
    heimbetreuerin = NEW.heimbetreuerin,
    betreuerin = NEW.betreuerin,
    lehrerin = NEW.lehrerin,
    mitbewohner = NEW.mitbewohner,
    partner_mutter = NEW.partner_mutter,
    partner_vater = NEW.partner_vater,
    freund = NEW.freund,
    keine_bezugsperson = NEW.keine_bezugsperson,
    hobbies_1 = NEW.hobbies_1,
    hobbies_text = NEW.hobbies_text,
    mitarbeit_organisationen = NEW.mitarbeit_organisationen,
    organisationen_vereine_text = NEW.organisationen_vereine_text,
    sonstiges_1 = NEW.sonstiges_1,
    sonstiges_text = NEW.sonstiges_text,
    clique = NEW.clique,
    freundin = NEW.freundin,
    parterin = NEW.parterin,
    schule_2 = NEW.schule_2,
    klassenstufe = NEW.klassenstufe,
    klassenwiederholung = NEW.klassenwiederholung,
    abgang = NEW.abgang,
    nicht_anwesende_tage = NEW.nicht_anwesende_tage,
    unentschuldigte_tage = NEW.unentschuldigte_tage,
    schulabschluss_1 = NEW.schulabschluss_1,
    schulabschlusserwerbsland = NEW.schulabschlusserwerbsland,
    schulabschlusserwerbsland_sonstige_nennung = NEW.schulabschlusserwerbsland_sonstige_nennung,
    abschluss_betriebliche_ausbildung = NEW.abschluss_betriebliche_ausbildung,
    abschluss_im_ausbildungsberuf = NEW.abschluss_im_ausbildungsberuf,
    ausbildungsdauer = NEW.ausbildungsdauer,
    wann_abgeschlossen = NEW.wann_abgeschlossen,
    weitere_ausbildungen = NEW.weitere_ausbildungen,
    weitere_ausbildungen_text = NEW.weitere_ausbildungen_text,
    dauer_weitere_ausbildungen = NEW.dauer_weitere_ausbildungen,
    abgebrochene_ausbildungen = NEW.abgebrochene_ausbildungen,
    abgebrochene_ausbildungen_text = NEW.abgebrochene_ausbildungen_text,
    abschluss_ausserbetriebliche_ausbildung = NEW.abschluss_ausserbetriebliche_ausbildung,
    abschluss_im_ausbildungsberuf_1 = NEW.abschluss_im_ausbildungsberuf_1,
    ausbildungsdauer_1 = NEW.ausbildungsdauer_1,
    wann_abgeschlossen_1 = NEW.wann_abgeschlossen_1,
    weitere_ausbildungen_1 = NEW.weitere_ausbildungen_1,
    weitere_ausbildungen_text_1 = NEW.weitere_ausbildungen_text_1,
    dauer_weitere_ausbildungen_1 = NEW.dauer_weitere_ausbildungen_1,
    abgebrochene_ausbildungen_1 = NEW.abgebrochene_ausbildungen_1,
    abgebrochene_ausbildungen_text_1 = NEW.abgebrochene_ausbildungen_text_1,
    massnahmeteilnahme = NEW.massnahmeteilnahme,
    letzte_massnahme = NEW.letzte_massnahme,
    finanzierung = NEW.finanzierung,
    austrittsdatum = NEW.austrittsdatum,
    dauer = NEW.dauer,
    weitere_massnahmen = NEW.weitere_massnahmen,
    massnahme_1 = NEW.massnahme_1,
    massnahme1_finanzierung = NEW.massnahme1_finanzierung,
    massnahme_2 = NEW.massnahme_2,
    massnahme2_finanzierung = NEW.massnahme2_finanzierung,
    massnahme_3 = NEW.massnahme_3,
    massnahme3_finanzierung = NEW.massnahme3_finanzierung,
    abgebrochene_massnahmen = NEW.abgebrochene_massnahmen,
    erwerbstaetigkeit_job = NEW.erwerbstaetigkeit_job,
    letzte_taetigkeit = NEW.letzte_taetigkeit,
    dauer_1 = NEW.dauer_1,
    austrittsdatum_1 = NEW.austrittsdatum_1,
    weitere_taetigkeiten = NEW.weitere_taetigkeiten,
    weitere_jobs_text = NEW.weitere_jobs_text,
    dauer_weitere_taetigkeiten = NEW.dauer_weitere_taetigkeiten,
    arbeitslosigkeit_1 = NEW.arbeitslosigkeit_1,
    anzahl_arbeitslosigkeit = NEW.anzahl_arbeitslosigkeit,
    dauer_nach_letzter_beschaeftigung = NEW.dauer_nach_letzter_beschaeftigung,
    dauer_insgesamt = NEW.dauer_insgesamt,
    wehrpflicht_zivildienst_freiwilligenjahr_1 = NEW.wehrpflicht_zivildienst_freiwilligenjahr_1,
    art_des_dienstes = NEW.art_des_dienstes,
    dauer_2 = NEW.dauer_2,
    mutterschutz_erziehungsurlaub = NEW.mutterschutz_erziehungsurlaub,
    anzahl = NEW.anzahl,
    dauer_letzter_erziehungsurlaub = NEW.dauer_letzter_erziehungsurlaub,
    dauer_insgesamt_1 = NEW.dauer_insgesamt_1,
    kompetenzfeststellung = NEW.kompetenzfeststellung,
    zielsetzung = NEW.zielsetzung,
    begleitung = NEW.begleitung,
    welche_vermittlung_nennung = NEW.welche_vermittlung_nennung,
    freie_dokumentation = NEW.freie_dokumentation,
    bildender_bereich = NEW.bildender_bereich,
    bereich_berufliche_qualifizierung = NEW.bereich_berufliche_qualifizierung,
    bereich_berufsvorbereitung = NEW.bereich_berufsvorbereitung,
    bereich_lebensbewaeltigung = NEW.bereich_lebensbewaeltigung,
    sonstiger_foerderbedarf = NEW.sonstiger_foerderbedarf,
    sonstiger_foerderbedarf_nennung = NEW.sonstiger_foerderbedarf_nennung,
    foerderzeitraum_start = NEW.foerderzeitraum_start,
    foerderzeitraum_ende = NEW.foerderzeitraum_ende,
    dokumentation_zum_foerderplan = NEW.dokumentation_zum_foerderplan,
    anzahl_kontakte_termine = NEW.anzahl_kontakte_termine,
    anzahl_der_stunden = NEW.anzahl_der_stunden,
    zeitraum_fallmanagement = NEW.zeitraum_fallmanagement,
    beendigung_5 = NEW.beendigung_5,
    art_beendigung = NEW.art_beendigung,
    abbruch_durch = NEW.abbruch_durch,
    gruende_abbruch = NEW.gruende_abbruch,
    gruende_sonstiges_nennung_4 = NEW.gruende_sonstiges_nennung_4,
    vermittlung = NEW.vermittlung,
    vermittlung_nennung = NEW.vermittlung_nennung,
    veraenderungen_rechtskreis = NEW.veraenderungen_rechtskreis,
    allgemein_bildender_schulabschluss = NEW.allgemein_bildender_schulabschluss,
    allgemein_bildender_schulabschluss_sonstiges_nennung = NEW.allgemein_bildender_schulabschluss_sonstiges_nennung,
    massnahmeabschluss = NEW.massnahmeabschluss,
    schulart = NEW.schulart,
    schule_sonstiges_nennung = NEW.schule_sonstiges_nennung,
    klassenstufe_1 = NEW.klassenstufe_1,
    ausbildung = NEW.ausbildung,
    ausbildung_sonstiges_nennung = NEW.ausbildung_sonstiges_nennung,
    umschulung = NEW.umschulung,
    umschulung_nennung = NEW.umschulung_nennung,
    arbeitstaetigkeit = NEW.arbeitstaetigkeit,
    erwerbstatus = NEW.erwerbstatus,
    erwerbsstatus_sonstiges_nennung = NEW.erwerbsstatus_sonstiges_nennung,
    beschaeftigungsumfang = NEW.beschaeftigungsumfang,
    kategorien_nichterwerbsarbeit_nichtausbildung = NEW.kategorien_nichterwerbsarbeit_nichtausbildung,
    kategorien_sonstiges_nennung = NEW.kategorien_sonstiges_nennung,
    zeitraum_nachbetreuung = NEW.zeitraum_nachbetreuung,
    verbleib_nachbetreuung = NEW.verbleib_nachbetreuung,
    mitgliedschaft_organisationen_vereinen = NEW.mitgliedschaft_organisationen_vereinen,
    intensitaet_mitgliedschaft = NEW.intensitaet_mitgliedschaft,
    nutzung_kulturangeboten = NEW.nutzung_kulturangeboten,
    haeufigkeit = NEW.haeufigkeit,
    soziales_engagement = NEW.soziales_engagement,
    unternehmungen_freunden = NEW.unternehmungen_freunden,
    unternehmungen_familie = NEW.unternehmungen_familie,
    peergroup = NEW.peergroup,
    familie_1 = NEW.familie_1,
    beziehung = NEW.beziehung,
    arbeit_schule = NEW.arbeit_schule,
    bester_freund_freundin = NEW.bester_freund_freundin,
    einschaetzung_zielerreichung = NEW.einschaetzung_zielerreichung,
    erreichte_qualifikation = NEW.erreichte_qualifikation,
    integration_ist_nachhaltig = NEW.integration_ist_nachhaltig,
    selbststaendige_berufswegplanung = NEW.selbststaendige_berufswegplanung,
    eigenstaendige_lebensgestaltung = NEW.eigenstaendige_lebensgestaltung,
    soziale_bezugssysteme = NEW.soziale_bezugssysteme,
    teilnahme_gesellschaftliches_leben = NEW.teilnahme_gesellschaftliches_leben,
    freie_dokumentation_abschlussbewertung = NEW.freie_dokumentation_abschlussbewertung
WHERE id = NEW.id;

CREATE OR REPLACE RULE master_tbl_delete_rule AS ON DELETE TO master_tbl_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE RULE master_tbl_insert_rule AS ON INSERT TO master_tbl_view
    DO INSTEAD NOTHING;

GRANT SELECT ON master_tbl_view TO GROUP :cm_ka_group;
GRANT UPDATE ON master_tbl_view TO GROUP :cm_ka_group;
GRANT SELECT ON master_tbl_view TO GROUP :admin_ka_group;

CREATE OR REPLACE VIEW rg_kompetenzfestellung_tbl_view
AS SELECT rg_kompetenzfestellung_tbl.* FROM rg_kompetenzfestellung_tbl
    INNER JOIN master_tbl
    ON         rg_kompetenzfestellung_tbl.master_id = master_tbl.id
WHERE
    master_tbl.bearbeiter_id = getuserid()
    OR master_tbl.id IN (
        SELECT nm.master_id from nm_benutzer_master_tbl nm
            WHERE nm.benutzer_id = getuserid())
    OR pg_has_role('admin_ka','MEMBER');

CREATE OR REPLACE RULE rg_kompetenzfestellung_tbl_update_rule AS ON UPDATE TO rg_kompetenzfestellung_tbl_view
DO INSTEAD UPDATE rg_kompetenzfestellung_tbl SET
    verfahren_kompetenzfeststellung = NEW.verfahren_kompetenzfeststellung,
    externeranbieter = NEW.externeranbieter,
    assessment_center = NEW.assessment_center,
    interview = NEW.interview,
    biografieorientierte_methoden = NEW.biografieorientierte_methoden,
    selbsttest_selbstbeurteilung = NEW.selbsttest_selbstbeurteilung,
    sonstiges_2 = NEW.sonstiges_2,
    artdesverfahrens_nennung_sonstiges = NEW.artdesverfahrens_nennung_sonstiges,
    testverfahren = NEW.testverfahren,
    intelligenztest = NEW.intelligenztest,
    intelligenztest_nennung = NEW.intelligenztest_nennung,
    schultest = NEW.schultest,
    schultest_nennung = NEW.schultest_nennung,
    leistungstest = NEW.leistungstest,
    leistungstest_nennung = NEW.leistungstest_nennung,
    persoenlichkeitstest = NEW.persoenlichkeitstest,
    persoenlichkeitstest_nennung = NEW.persoenlichkeitstest_nennung,
    einstellungs_interessentest = NEW.einstellungs_interessentest,
    einstellungs_interessentest_nennung = NEW.einstellungs_interessentest_nennung,
    dauer_des_verfahrens = NEW.dauer_des_verfahrens,
    rechenfaehigkeit = NEW.rechenfaehigkeit,
    raeumliches_vorstellungsvermoegen = NEW.raeumliches_vorstellungsvermoegen,
    grundverstaendnis_naturwissenschaftlicher_zusammenhaenge = NEW.grundverstaendnis_naturwissenschaftlicher_zusammenhaenge,
    logisches_denken = NEW.logisches_denken,
    wirtschaftliche_grundkenntnisse = NEW.wirtschaftliche_grundkenntnisse,
    allgemeine_pc_kenntnisse = NEW.allgemeine_pc_kenntnisse,
    spezielle_pc_kenntnisse_grafikbearbeitung_musikbearbeitung = NEW.spezielle_pc_kenntnisse_grafikbearbeitung_musikbearbeitung,
    internet_anwendungen_und_e_mail_kenntnisse = NEW.internet_anwendungen_und_e_mail_kenntnisse,
    andere_medien = NEW.andere_medien,
    hand_fingergeschick = NEW.hand_fingergeschick,
    formauffassung = NEW.formauffassung,
    umgang_maschinen_werkzeugen = NEW.umgang_maschinen_werkzeugen,
    gestalterische_fantasie = NEW.gestalterische_fantasie,
    methoden_der_informationsgewinnung = NEW.methoden_der_informationsgewinnung,
    methoden_der_informationsverarbeitung = NEW.methoden_der_informationsverarbeitung,
    einsatz_lern_und_arbeitstechniken = NEW.einsatz_lern_und_arbeitstechniken,
    problemloesungsorientierung = NEW.problemloesungsorientierung,
    texte_lesen_und_verstehen = NEW.texte_lesen_und_verstehen,
    texte_schreiben_und_formulieren = NEW.texte_schreiben_und_formulieren,
    deutsche_sprache = NEW.deutsche_sprache,
    sprache1 = NEW.sprache1,
    sprache1_sonstige_nennung = NEW.sprache1_sonstige_nennung,
    beherrschung_sprache1 = NEW.beherrschung_sprache1,
    sprache2 = NEW.sprache2,
    sprache2_sonstige_nennung = NEW.sprache2_sonstige_nennung,
    beherrschung_sprache2 = NEW.beherrschung_sprache2,
    sprache3 = NEW.sprache3,
    sprache3_sonstige_nennung = NEW.sprache3_sonstige_nennung,
    beherrschung_sprache3 = NEW.beherrschung_sprache3,
    kommunikationsfaehigkeit = NEW.kommunikationsfaehigkeit,
    kritikfaehigkeit = NEW.kritikfaehigkeit,
    konfliktfaehigkeit = NEW.konfliktfaehigkeit,
    kreativitaet = NEW.kreativitaet,
    team_und_kooperationsfaehigkeit = NEW.team_und_kooperationsfaehigkeit,
    solidarisches_verhalten = NEW.solidarisches_verhalten,
    selbstaendiges_lernen_arbeiten = NEW.selbstaendiges_lernen_arbeiten,
    selbstreflexion_selbsteinschaetzung = NEW.selbstreflexion_selbsteinschaetzung,
    verantwortungsuebernahme = NEW.verantwortungsuebernahme,
    zielorientierung = NEW.zielorientierung,
    zuverlaessigkeit = NEW.zuverlaessigkeit,
    altersgerechter_entwicklungsstand = NEW.altersgerechter_entwicklungsstand,
    gesundheitliche_voraussetzungen = NEW.gesundheitliche_voraussetzungen,
    konzentration = NEW.konzentration,
    ausdauer = NEW.ausdauer,
    durchhaltevermoegen = NEW.durchhaltevermoegen,
    merkfaehigkeit = NEW.merkfaehigkeit,
    bearbeitungsgeschwindigkeit = NEW.bearbeitungsgeschwindigkeit,
    befaehigung_zu_daueraufmerksamkeit = NEW.befaehigung_zu_daueraufmerksamkeit,
    leistungsbereitschaft = NEW.leistungsbereitschaft,
    sorgfalt = NEW.sorgfalt,
    umgangsformen = NEW.umgangsformen,
    dokumentation_kompetenzfeststellung = NEW.dokumentation_kompetenzfeststellung
WHERE id = NEW.id;

CREATE OR REPLACE RULE rg_kompetenzfestellung_tbl_delete_rule AS ON DELETE TO rg_kompetenzfestellung_tbl_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE RULE rg_kompetenzfestellung_tbl_insert_rule AS ON INSERT TO rg_kompetenzfestellung_tbl_view
    DO INSTEAD NOTHING;

GRANT SELECT ON rg_kompetenzfestellung_tbl_view TO GROUP :cm_ka_group;
GRANT UPDATE ON rg_kompetenzfestellung_tbl_view TO GROUP :cm_ka_group;
GRANT SELECT ON rg_kompetenzfestellung_tbl_view TO GROUP :admin_ka_group;

CREATE OR REPLACE VIEW rg_angebote_bildenden_bereich_tbl_view
AS SELECT rg_angebote_bildenden_bereich_tbl.* FROM rg_angebote_bildenden_bereich_tbl
    INNER JOIN master_tbl
    ON         rg_angebote_bildenden_bereich_tbl.master_id = master_tbl.id
WHERE
    master_tbl.bearbeiter_id = getuserid()
    OR master_tbl.id IN (
        SELECT nm.master_id from nm_benutzer_master_tbl nm
            WHERE nm.benutzer_id = getuserid())
    OR pg_has_role('admin_ka','MEMBER');

CREATE OR REPLACE RULE rg_angebote_bildenden_bereich_tbl_update_rule AS ON UPDATE TO rg_angebote_bildenden_bereich_tbl_view
DO INSTEAD UPDATE rg_angebote_bildenden_bereich_tbl SET
    angebotsform = NEW.angebotsform,
    art_der_unterstuetzung = NEW.art_der_unterstuetzung,
    durchfuehrende_institution = NEW.durchfuehrende_institution,
    unterstuetzung_start = NEW.unterstuetzung_start,
    unterstuetzung_ende = NEW.unterstuetzung_ende,
    zeitlicher_umfang_unterstuetzung = NEW.zeitlicher_umfang_unterstuetzung,
    beendigung_1 = NEW.beendigung_1,
    beendigung_durch = NEW.beendigung_durch,
    gruende_vorzeitige_beendigung = NEW.gruende_vorzeitige_beendigung,
    gruende_sonstiges_nennung = NEW.gruende_sonstiges_nennung,
    nachweis_bescheinigung = NEW.nachweis_bescheinigung,
    sonstiges_nachweis_bescheinigung = NEW.sonstiges_nachweis_bescheinigung
WHERE id = NEW.id;

CREATE OR REPLACE RULE rg_angebote_bildenden_bereich_tbl_delete_rule AS ON DELETE TO rg_angebote_bildenden_bereich_tbl_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE RULE rg_angebote_bildenden_bereich_tbl_insert_rule AS ON INSERT TO rg_angebote_bildenden_bereich_tbl_view
    DO INSTEAD NOTHING;

GRANT SELECT ON rg_angebote_bildenden_bereich_tbl_view TO GROUP :cm_ka_group;
GRANT UPDATE ON rg_angebote_bildenden_bereich_tbl_view TO GROUP :cm_ka_group;
GRANT SELECT ON rg_angebote_bildenden_bereich_tbl_view TO GROUP :admin_ka_group;

CREATE OR REPLACE VIEW rg_angebote_berufsvorbereitung_tbl_view
AS SELECT rg_angebote_berufsvorbereitung_tbl.* FROM rg_angebote_berufsvorbereitung_tbl
    INNER JOIN master_tbl
    ON         rg_angebote_berufsvorbereitung_tbl.master_id = master_tbl.id
WHERE
    master_tbl.bearbeiter_id = getuserid()
    OR master_tbl.id IN (
        SELECT nm.master_id from nm_benutzer_master_tbl nm
            WHERE nm.benutzer_id = getuserid())
    OR pg_has_role('admin_ka','MEMBER');

CREATE OR REPLACE RULE rg_angebote_berufsvorbereitung_tbl_update_rule AS ON UPDATE TO rg_angebote_berufsvorbereitung_tbl_view
DO INSTEAD UPDATE rg_angebote_berufsvorbereitung_tbl SET
    angebotsform_1 = NEW.angebotsform_1,
    art_der_unterstuetzung_1 = NEW.art_der_unterstuetzung_1,
    unterstuetzung_sonstiges_nennung = NEW.unterstuetzung_sonstiges_nennung,
    durchfuehrende_institution_1 = NEW.durchfuehrende_institution_1,
    unterstuetzung_start_1 = NEW.unterstuetzung_start_1,
    unterstuetzung_ende_1 = NEW.unterstuetzung_ende_1,
    zeitlicher_umfang_unterstuetzung_1 = NEW.zeitlicher_umfang_unterstuetzung_1,
    beendigung_2 = NEW.beendigung_2,
    beendigung_durch_1 = NEW.beendigung_durch_1,
    gruende_vorzeitige_beendigung_1 = NEW.gruende_vorzeitige_beendigung_1,
    gruende_sonstiges_nennung_1 = NEW.gruende_sonstiges_nennung_1,
    nachweis_bescheinigung_1 = NEW.nachweis_bescheinigung_1,
    sonstiges_nachweis_bescheinigung_1 = NEW.sonstiges_nachweis_bescheinigung_1
WHERE id = NEW.id;

CREATE OR REPLACE RULE rg_angebote_berufsvorbereitung_tbl_delete_rule AS ON DELETE TO rg_angebote_berufsvorbereitung_tbl_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE RULE rg_angebote_berufsvorbereitung_tbl_insert_rule AS ON INSERT TO rg_angebote_berufsvorbereitung_tbl_view
    DO INSTEAD NOTHING;

GRANT SELECT ON rg_angebote_berufsvorbereitung_tbl_view TO GROUP :cm_ka_group;
GRANT UPDATE ON rg_angebote_berufsvorbereitung_tbl_view TO GROUP :cm_ka_group;
GRANT SELECT ON rg_angebote_berufsvorbereitung_tbl_view TO GROUP :admin_ka_group;

CREATE OR REPLACE VIEW rg_angebote_berufliche_qualifizierung_tbl_view
AS SELECT rg_angebote_berufliche_qualifizierung_tbl.* FROM rg_angebote_berufliche_qualifizierung_tbl
    INNER JOIN master_tbl
    ON         rg_angebote_berufliche_qualifizierung_tbl.master_id = master_tbl.id
WHERE
    master_tbl.bearbeiter_id = getuserid()
    OR master_tbl.id IN (
        SELECT nm.master_id from nm_benutzer_master_tbl nm
            WHERE nm.benutzer_id = getuserid())
    OR pg_has_role('admin_ka','MEMBER');

CREATE OR REPLACE RULE rg_angebote_berufliche_qualifizierung_tbl_update_rule AS ON UPDATE TO rg_angebote_berufliche_qualifizierung_tbl_view
DO INSTEAD UPDATE rg_angebote_berufliche_qualifizierung_tbl SET
    angebotsform_2 = NEW.angebotsform_2,
    angebote_im_bereich = NEW.angebote_im_bereich,
    unterstuetzung_sonstiges_nennung_1 = NEW.unterstuetzung_sonstiges_nennung_1,
    durchfuehrende_institution_2 = NEW.durchfuehrende_institution_2,
    unterstuetzung_start_2 = NEW.unterstuetzung_start_2,
    unterstuetzung_ende_2 = NEW.unterstuetzung_ende_2,
    zeitlicher_umfang_unterstuetzung_2 = NEW.zeitlicher_umfang_unterstuetzung_2,
    beendigung_3 = NEW.beendigung_3,
    beendigung_durch_2 = NEW.beendigung_durch_2,
    gruende_vorzeitige_beendigung_2 = NEW.gruende_vorzeitige_beendigung_2,
    gruende_sonstiges_nennung_2 = NEW.gruende_sonstiges_nennung_2,
    nachweis_bescheinigung_2 = NEW.nachweis_bescheinigung_2,
    sonstiges_nachweis_bescheinigung_2 = NEW.sonstiges_nachweis_bescheinigung_2
WHERE id = NEW.id;

CREATE OR REPLACE RULE rg_angebote_berufliche_qualifizierung_tbl_delete_rule AS ON DELETE TO rg_angebote_berufliche_qualifizierung_tbl_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE RULE rg_angebote_berufliche_qualifizierung_tbl_insert_rule AS ON INSERT TO rg_angebote_berufliche_qualifizierung_tbl_view
    DO INSTEAD NOTHING;

GRANT SELECT ON rg_angebote_berufliche_qualifizierung_tbl_view TO GROUP :cm_ka_group;
GRANT UPDATE ON rg_angebote_berufliche_qualifizierung_tbl_view TO GROUP :cm_ka_group;
GRANT SELECT ON rg_angebote_berufliche_qualifizierung_tbl_view TO GROUP :admin_ka_group;

CREATE OR REPLACE VIEW rg_angebote_lebensbewaeltigung_tbl_view
AS SELECT rg_angebote_lebensbewaeltigung_tbl.* FROM rg_angebote_lebensbewaeltigung_tbl
    INNER JOIN master_tbl
    ON         rg_angebote_lebensbewaeltigung_tbl.master_id = master_tbl.id
WHERE
    master_tbl.bearbeiter_id = getuserid()
    OR master_tbl.id IN (
        SELECT nm.master_id from nm_benutzer_master_tbl nm
            WHERE nm.benutzer_id = getuserid())
    OR pg_has_role('admin_ka','MEMBER');

CREATE OR REPLACE RULE rg_angebote_lebensbewaeltigung_tbl_update_rule AS ON UPDATE TO rg_angebote_lebensbewaeltigung_tbl_view
DO INSTEAD UPDATE rg_angebote_lebensbewaeltigung_tbl SET
    angebotsform_3 = NEW.angebotsform_3,
    unterstuetzung_angebotsform_sonstiges_nennung = NEW.unterstuetzung_angebotsform_sonstiges_nennung,
    art_der_unterstuetzung_2 = NEW.art_der_unterstuetzung_2,
    unterstuetzung_sonstiges_nennung_2 = NEW.unterstuetzung_sonstiges_nennung_2,
    durchfuehrende_institution_3 = NEW.durchfuehrende_institution_3,
    unterstuetzung_start_3 = NEW.unterstuetzung_start_3,
    unterstuetzung_ende_3 = NEW.unterstuetzung_ende_3,
    zeitlicher_umfang_unterstuetzung_3 = NEW.zeitlicher_umfang_unterstuetzung_3,
    beendigung_4 = NEW.beendigung_4,
    beendigung_durch_3 = NEW.beendigung_durch_3,
    gruende_vorzeitige_beendigung_3 = NEW.gruende_vorzeitige_beendigung_3,
    gruende_sonstiges_nennung_3 = NEW.gruende_sonstiges_nennung_3,
    nachweis_bescheinigung_3 = NEW.nachweis_bescheinigung_3,
    sonstiges_nachweis_bescheinigung_3 = NEW.sonstiges_nachweis_bescheinigung_3
WHERE id = NEW.id;

CREATE OR REPLACE RULE rg_angebote_lebensbewaeltigung_tbl_delete_rule AS ON DELETE TO rg_angebote_lebensbewaeltigung_tbl_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE RULE rg_angebote_lebensbewaeltigung_tbl_insert_rule AS ON INSERT TO rg_angebote_lebensbewaeltigung_tbl_view
    DO INSTEAD NOTHING;

GRANT SELECT ON rg_angebote_lebensbewaeltigung_tbl_view TO GROUP :cm_ka_group;
GRANT UPDATE ON rg_angebote_lebensbewaeltigung_tbl_view TO GROUP :cm_ka_group;
GRANT SELECT ON rg_angebote_lebensbewaeltigung_tbl_view TO GROUP :admin_ka_group;

COMMIT;
