<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet
    version="1.0"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

    <xsl:output method="xml" encoding="UTF-8" />

    <xsl:template match="tagebuch-art" mode="logbook">
        <xsl:copy>-2</xsl:copy>
        <xsl:variable name="misc" select="../tagebuch-sonstiges/text()"/>
        <tagebuch-sonstiges>
            <xsl:text>Erstgespräch</xsl:text>
            <xsl:if test="$misc">
                <xsl:text>: </xsl:text>
                <xsl:value-of select="$misc"/>
            </xsl:if>
        </tagebuch-sonstiges>
    </xsl:template>

    <xsl:template match="tagebuch-sonstiges" mode="logbook" />

    <xsl:template match="@*|node()" mode="logbook">
        <xsl:copy>
          <xsl:apply-templates select="@*|node()"/>
        </xsl:copy>
    </xsl:template>

    <xsl:template match="tagebuch-eintrag">
        <xsl:copy>
            <xsl:choose>
                <xsl:when test="./tagebuch-art/text() = '9'">
                    <xsl:apply-templates select="@*|node()" mode="logbook"/>
                </xsl:when>
                <xsl:otherwise>
                    <xsl:apply-templates select="@*|node()"/>
                </xsl:otherwise>
            </xsl:choose>
        </xsl:copy>
    </xsl:template>

    <xsl:template match="zeitraum_nachbetreuung|beendigung_nachbetreuung|verbleib_nachbetreuung" />

    <xsl:template match="master">
        <xsl:copy>
          <xsl:apply-templates select="@*|node()"/>

          <xsl:variable name="zeitraum_nachbetreuung" select="./zeitraum_nachbetreuung/text()"/>
          <xsl:variable name="verbleib_nachbetreuung" select="./verbleib_nachbetreuung/text()"/>
          <xsl:variable name="beendigung_nachbetreuung" select="./beendigung_nachbetreuung/text()"/>

          <xsl:if test="$zeitraum_nachbetreuung">
            <zeitraum_nachbetreuung>
                <xsl:value-of select="$zeitraum_nachbetreuung"/>
            </zeitraum_nachbetreuung>
          </xsl:if>
          <xsl:if test="$verbleib_nachbetreuung">
            <verbleib_nachbetreuung>
                <xsl:value-of select="$verbleib_nachbetreuung"/>
            </verbleib_nachbetreuung>
          </xsl:if>
          <xsl:if test="$beendigung_nachbetreuung">
            <beendigung_nachbetreuung>
                <xsl:value-of select="$beendigung_nachbetreuung"/>
            </beendigung_nachbetreuung>
          </xsl:if>
        </xsl:copy>
    </xsl:template>

    <xsl:template match="@*|node()">
        <xsl:copy>
          <xsl:apply-templates select="@*|node()"/>
        </xsl:copy>
    </xsl:template>

</xsl:stylesheet>    
