<?xml version="1.0" encoding="iso-8859-1"?>
<!--
    index-dependencies.xsl

    Einfache Transformation, die Abhaengigkeiten der
    Index-Tabellen textuell darstellt.

    Autor: Sascha L. Teichmann (teichmann@intevation.de)

    (C) 2008 by Intevation GmbH
-->
<xsl:stylesheet
    version="1.0"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:xs="http://www.w3.org/2001/XMLSchema"
    xmlns:xhtml="http://www.w3.org/1999/xhtml">

    <xsl:output method="text" encoding="UTF-8" />

    <xsl:key
        name="enum-to-types"
        match="xs:simpleType/xs:restriction[starts-with(@base, 'enum_')]/.."
        use="./xs:restriction/@base"/>

    <xsl:template match="xs:simpleType[starts-with(@name, 'enum_')]">
        <xsl:text>  Tabelle #</xsl:text>
        <xsl:value-of select="substring-before(substring-after(@name, 'enum_'), '_type') + 1"/>
        <xsl:text>:&#10;    Werte:&#10;</xsl:text>
        <xsl:for-each select="./xs:annotation/xs:documentation/xhtml:table/xhtml:tr[position() > 1]">
            <xsl:text>      </xsl:text>
            <xsl:value-of select="./xhtml:td[1]"/>
            <xsl:text>: </xsl:text>
            <xsl:value-of select="./xhtml:td[2]"/>
            <xsl:text>&#10;</xsl:text>
        </xsl:for-each>
        <xsl:text>    Bezug:&#10;</xsl:text>
        <xsl:for-each select="key('enum-to-types', @name)">
            <xsl:text>      </xsl:text>
            <xsl:value-of select="substring-before(@name, '_type')"/>
            <xsl:text>&#10;</xsl:text>
        </xsl:for-each>
        <xsl:text>&#10;</xsl:text>
    </xsl:template>

    <xsl:template match="/">
        <xsl:text>Index-Tabellen:&#10;</xsl:text>
        <xsl:apply-templates/>
    </xsl:template>

    <xsl:template match="text()" />

</xsl:stylesheet>
