<?xml version="1.0" encoding="iso-8859-1"?>
<!--
    list-semantics.xsl

    Listet die Felder und ihre Bedeutung und falls es sich um
    eine Auswahlliste handelt auch die entsprechende Wertebelegung.

    Autor: Sascha L. Teichmann (teichmann@intevation.de)

    (C) 2008 by Intevation GmbH
-->

<xsl:stylesheet
    version="1.0"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:xs="http://www.w3.org/2001/XMLSchema"
    xmlns:xhtml="http://www.w3.org/1999/xhtml">

    <xsl:output method="text" encoding="UTF-8" />

    <xsl:template match="xhtml:tr[position() > 1]" mode="html-values">
        <xsl:text>            </xsl:text>
        <xsl:value-of select="./xhtml:td[1]"/>
        <xsl:text>: </xsl:text>
        <xsl:value-of select="./xhtml:td[2]"/>
        <xsl:text>&#10;</xsl:text>
    </xsl:template>

    <xsl:template match="xhtml:li" mode="html-out">
        <xsl:text>            </xsl:text>
        <xsl:value-of select="text()"/>
        <xsl:text>&#10;</xsl:text>
    </xsl:template>

    <xsl:template match="xs:simpleType[starts-with(@name, 'enum_') = false and @name != 'uuid_type' and @name != 'simple_date_type']">
        <xsl:text>    </xsl:text>
        <xsl:value-of select="substring-before(@name, '_type')"/>
        <xsl:text>&#10;</xsl:text>
        <xsl:text>        Bedeutung:&#10;</xsl:text>
        <xsl:apply-templates mode="html-out"/>
        <xsl:text>&#10;</xsl:text>
        <xsl:variable name="my-base" select='./xs:restriction/@base'/>
        <xsl:if test="starts-with($my-base, 'enum_')">
            <xsl:text>        Werte:&#10;</xsl:text>
            <xsl:apply-templates mode="html-values" select="//xs:simpleType[@name = $my-base]"/>
        </xsl:if>
        <xsl:text>&#10;</xsl:text>
    </xsl:template>

    <xsl:template match="/">
        <xsl:text>Felder:&#10;</xsl:text>
        <xsl:apply-templates/>
    </xsl:template>

    <xsl:template match="text()" />
    <xsl:template match="text()" mode="html-out"/>
    <xsl:template match="text()" mode="html-values"/>

</xsl:stylesheet>

